#include "ion.h"

unsigned char random(unsigned char upper_bound)
{
	upper_bound;
	__asm
	LD B, 4(IX);
	PUSH HL;
	PUSH DE;
	LD	HL, (#0x91BF);
	LD	A, R;
	LD	D, A;
	LD	E, (HL);
	ADD	HL, DE;
	ADD	A, L;
	XOR	H;
	LD(#0x91BF), HL;
	SBC	HL, HL;
	LD	E, A;
	LD	D, H;
randomLoop:
	ADD	HL, DE;
	DJNZ randomLoop;
	LD	A, H;
	POP	DE;
	POP	HL;
	LD L, A;
	__endasm;
}
extern void putSprite(unsigned char x, unsigned char y, void* sprite, unsigned char height)
{
	x;//A
	y;//E
	sprite;//IX
	height;//B
	__asm
	LD A, 4(IX);
	LD E, 5(IX);
	LD L, 6(IX);
	LD H, 7(IX);
	LD B, 8(IX);
	PUSH HL;
	EX(SP), IX;
	LD	H, #0x0;
	LD	D, H;
	SLA E;// *2
	SLA E;// *4
	LD	L, E;
	ADD	HL, DE;// *2	faster:*8
	ADD	HL, DE;// *3	faster:*12
	LD E, A;
	SRL	E;
	SRL	E;
	SRL	E;
	ADD	HL, DE;
	LD	DE, #0x9340;
	ADD	HL, DE;
	AND #0x7;
	LD C, A;
putSpriteLoop1:
	LD D, (IX);
	LD E, #0x0;
	LD A, C;
	OR A;
	JR Z, putSpriteSkip1;
putSpriteLoop2:
	SRL	D;
	RR	E;
	DEC	A;
	JR	NZ, putSpriteLoop2;
putSpriteSkip1:
	LD	A, (HL);
	XOR D;
	LD(HL), A;
	INC	HL;
	LD	A, (HL);
	XOR E;
	LD(HL), A;
	LD	DE, #0xB;
	ADD HL, DE;
	INC	IX;
	DJNZ putSpriteLoop1;
	POP IX;
	__endasm;
}

extern void largeSprite(unsigned char x, unsigned char y, unsigned char widthInByte, unsigned char height, void* sprite)
{
	x;//A
	y;//E
	widthInByte;//C
	height;//B
	sprite;//IX
	__asm
	LD A, 4(IX);
	LD E, 5(IX);
	LD C, 6(IX);
	LD B, 7(IX);
	LD L, 8(IX);
	LD H, 9(IX);
	PUSH HL;
	EX(SP), IX;
	DI;
	EX AF, AF;
	LD A, C;
	PUSH  AF;
	EX AF, AF;
	LD L, E;
	LD H, #0x0;
	LD D, H;
	ADD HL, DE;
	ADD HL, DE;
	ADD HL, HL;
	ADD HL, HL;
	LD E, A;
	AND #0x7;
	LD C, A;
	SRL E;
	SRL E;
	SRL E;
	ADD HL, DE;
	LD DE, #0x9340;
	ADD HL, DE;
largeSpriteLoop1:
	PUSH HL;
largeSpriteLoop2 :
	LD D, (IX);
	LD E, #0x0;
	LD A, C;
	OR A;
	JR Z, largeSpriteSkip1;
largeSpriteLoop3:
	SRL D;
	RR E;
	DEC A;
	JR NZ, largeSpriteLoop3;
largeSpriteSkip1:
	LD A, (HL);
	XOR D;
	LD(HL), A;
	INC HL;
	LD A, (HL);
	XOR E;
	LD(HL), A;
	INC IX;
	EX AF, AF;
	DEC A;
	PUSH AF;
	EX AF, AF;
	POP AF;
	JR NZ, largeSpriteLoop2;
	POP HL;
	POP AF;
	PUSH AF;
	EX AF, AF;
	LD DE, #0xC;
	ADD HL, DE;
	DJNZ largeSpriteLoop1;
	POP AF;
	POP IX;
	__endasm;
}

void fastCopy()
{
	__asm
	DI;
	LD	A, #0x80;// 7
	OUT(#0x10), A;// 11
	LD	HL, #0x9633;// 10
	LD	A, #0x20;// 7
	LD	C, A;// 4
	INC	HL;// 6 waste
	DEC	HL;// 6 waste
fastCopyAgain:
	LD	B, #0x40;// 7
	INC	C;// 4
	LD	DE, #0xFD01;// 10
	OUT(#0x10), A;// 11
	ADD	HL, DE;// 11
	LD	DE, #0xA; 10
fastCopyLoop:
	ADD	HL, DE;// 11
	INC	HL;// 6 waste
	INC	HL;// 6 waste
	INC	DE;// 6
	LD	A, (HL);// 7
	OUT(#0x11), A;// 11
	DEC	DE;// 6
	DJNZ fastCopyLoop;// 13 / 8
	LD	A, C;// 4
	CP	#0x2C;// 7
	JR	NZ, fastCopyAgain;// 10 / 1
	__endasm;
}

void VerticalLine(unsigned char x)
{
	x;
	__asm
	LD A, 4(IX);
	LD HL, #0x9340;
	LD D, #0x0;
	LD E, A;
	SRL E;
	SRL E;
	SRL E;
	ADD HL, DE;
	AND #0x7;
	LD B, A;
	INC B;
	LD A, #0x1;
vertloop1:
	RRCA;
	DJNZ vertloop1;
	LD C, A;
	LD B, #0x40;
	LD E, #0xC;
vertloop2:
	LD A, C;
	OR(HL);
	LD(HL), A;
	ADD HL, DE;
	DJNZ vertloop2;
	__endasm;
}

void HorizontalLine(unsigned char x)
{
	x;
	__asm
	LD A, 4(IX);
	LD L, A;
	LD H, #0x0;
	ADD A, A;
	ADD A, L;
	LD L, A;
	ADD HL, HL;
	ADD HL, HL;
	LD BC, #0x9340;
	ADD HL, BC;
	LD B, #0xC;
horizloop:
	LD(HL), #0xFF;
	INC HL;
	DJNZ horizloop;
	__endasm;
}
